define(["vue","MINT", "Util", "txt!../../pages/deviceInfo.html" ],
    function(v, MINT, Util, deviceInfo) {

        var DeviceInfo = v.extend({

            template: deviceInfo,
            props: {
                deviceInfo: {
                    type: Object
                }
            },
            data: function(){
                return {
                    showFlag: false,
                }
            },
            methods:{
                show: function() {
                    window.onBackPressed = this.hide;
                    this.showFlag = true;
                },
                hide: function () {
                    this.$emit("deviceInfoShow");
                    this.showFlag = false;
                },
                getMac: function(mac) {
                    return Util.strSplit(mac).join(":");
                },
                getModel: function(tid) {
                    var model = "";
                    if (tid == TABLE_LAMP_LIGHT) {
                        model = "LORA Table Lamp";
                    } else if (tid == FLOOR_LAMP_LIGHT) {
                        model = "LORA Floor Lamp";
                    } else if (tid == CHANDELIER_LIGHT) {
                        model = "LORA Chandelier"
                    }else if (tid == WALL_LAMP_LIGHT) {
                        model = "LORA Wall Lamp"
                    }
                    return model;
                }
            }

        });
        return DeviceInfo;
    });