define(["vue","MINT", "Util", "txt!../../pages/operateDevice.html", "../js/colorPicker", "../js/deviceInfo" ],
    function(v, MINT, Util, operateDevice, colorPicker, deviceInfo) {

    var OperateDevice = v.extend({

        template: operateDevice,
        props: {
            colorId: {
                type: String
            },
            temperatureId: {
                type: String
            },
            isDevice: {
                type: String
            },
            isRoom: {
                type: String
            }
        },
        data: function(){
            return {
                addFlag: false,
                deviceMacs: "",
                name: "",
                isShowMore: false,
                operateType: RECENT_TYPE_DEVICE,
                device: ""
            }
        },
        computed: {

        },
        methods:{
            show: function() {
                var self = this;
                self.hideThis();
                self.device = self.$store.state.deviceInfo;
                self.name = self.device.name;
                if (!self.$parent.isDevice) {
                    self.deviceMacs = self.device.macs;
                    self.operateType = "";
                    self.isShowMore = false;
                } else {
                    self.operateType = RECENT_TYPE_DEVICE;
                    self.deviceMacs = [self.device.mac];
                    self.isShowMore = true;
                }
                self.addFlag = true;
                setTimeout(function() {
                    self.$refs.color.show()
                })
            },
            showDeviceInfo: function() {
                var self = this;
                setTimeout(function() {
                    self.$refs.info.show();
                })
            },
            hideThis: function() {
                window.onBackPressed = this.hide;
            },
            hide: function () {
                this.addFlag = false;
                this.$store.commit("setShowScanBle", true);
                this.$emit("operateShow");
            },
        },
        components: {
            "v-color": colorPicker,
            "v-deviceInfo": deviceInfo
        }

    });

    return OperateDevice;
});